
import javax.swing.*;

// ----------------------------------------------------------------------------
/**
 * This class is a demo driver for the 'broken' {@link IFoo} implementation in
 * {@link EvilFoo}. Make sure you have the 'classes' directory from the download
 * in your classpath when running it.
 * 
 * @author (C) <a href="mailto:vroubtsov@illinoisalumni.org">Vlad Roubtsov</a>, 2003
 */
public class Main
{
    // public: ................................................................
    
    public static void main (final String[] args)
    {
        // this try/catch block appears to intercept all exceptions that
        // IFoo.bar() can throw; however, this is not true as you can discover
        // by running this class
        try
        {            
            IFoo foo = new EvilFoo (new java.io.IOException ("SURPRISE!"));
            foo.bar ();
        }
        catch (RuntimeException ioe)
        {
            // ignore ioe
        }
        catch (Error e)
        {
            // ignore e
        }
        
        // comment out the code above and uncomment the next line to experiment
        // with the deadlock situation as described in the article:  
        //SwingUtilities.invokeAndWait (new EvilFoo (new Throwable ("SURPRISE!")));
    }
    
    // protected: .............................................................

    // package: ...............................................................

    // private: ...............................................................

} // end of class
// ----------------------------------------------------------------------------

